/*Jason Larsen*/
/*anonpoet@inconnu.isu.edu*/

/* Hogwash Detection Plugin Source File for Direction Check */

/* sp_direction
 * 
 * Purpose:
 *
 * To make rules only function on incomming or outgoing traffic
 *
 * Arguments:
 *   
 * None
 *
 */

#include "sp_direction.h"

extern char *file_name;  /* this is the file name from rules.c, generally used
                            for error messages */

extern int file_line;    /* this is the file line number from rules.c that is
                            used to indicate file lines for error messages */

void SetupDirection()
{
    /* map the keyword to an initialization/processing function */
    RegisterPlugin("incomming", DirectionInitIn);
	RegisterPlugin("outgoing", DirectionInitOut);

#ifdef DEBUG
    printf("Plugin: Direction Setup\n");
#endif
}

void DirectionInitIn(char *data, OptTreeNode *otn, int protocol)
{
    /* allocate the data structure and attach it to the
       rule's data struct list */
    otn->ds_list[PLUGIN_DIRECTION] = (DirectionData *) calloc(sizeof(DirectionData), sizeof(char));

	((DirectionData *)otn->ds_list[PLUGIN_DIRECTION])->Incomming=TRUE;

    /* this is where the keyword arguments are processed and placed into the 
       rule option's data structure */
    ParseDirection(data, otn);


    /* finally, attach the option's detection function to the rule's 
       detect function pointer list */
    AddOptFuncToList(CheckDirection, otn);
}

void DirectionInitOut(char *data, OptTreeNode *otn, int protocol)
{
    /* allocate the data structure and attach it to the
       rule's data struct list */
    otn->ds_list[PLUGIN_DIRECTION] = (DirectionData *) calloc(sizeof(DirectionData), sizeof(char));

	((DirectionData *)otn->ds_list[PLUGIN_DIRECTION])->Incomming=FALSE;

    /* this is where the keyword arguments are processed and placed into the 
       rule option's data structure */
    ParseDirection(data, otn);


    /* finally, attach the option's detection function to the rule's 
       detect function pointer list */
    AddOptFuncToList(CheckDirection, otn);
}


void ParseDirection(char *data, OptTreeNode *otn)
{
}


/****************************************************************************
 * 
 * Function: TemplateDetectorFunction(char *, OptTreeNode *)
 *
 * Purpose: Use this function to perform the particular detection routine
 *          that this rule keyword is supposed to encompass.
 *
 * Arguments: data => argument data
 *            otn => pointer to the current rule's OTN
 *
 * Returns: If the detection test fails, this function *must* return a zero!
 *          On success, it calls the next function in the detection list 
 *
 ****************************************************************************/
int CheckDirection(Packet *p, struct _OptTreeNode *otn, OptFpList *fp_list)
{
    DirectionData *dir;

    dir = otn->ds_list[PLUGIN_DIRECTION];

	return (dir->Incomming==p->interface_num);
}
